function Output=FC2DCHChekerboard(x1,x2,d1,d2,epsilona,epsilonb,M,N)

%% 2D Toeplitz Matrix for checkerboard grating [[e]] and [[1/e]]
%% 920426

l1=x1(1);
l3=x1(2);
l5=x1(3);
l2=x2(1);
l4=x2(2);
l6=x2(3);
q=sqrt(-1);    
X=zeros((2*N+1),(4*M+1)*(2*N+1));
for m=-2*M:2*M
    X(:,((m+2*M)*(2*N+1)+1):((m+2*M+1)*(2*N+1)))=FC2DCh(m,l1,l3,l5,l2,l4,l6,d1,d2,epsilona,epsilonb,N);
end

Output=zeros((2*M+1)*(2*N+1));
for m=-M:M
    for j=-M:M
        Output(((m+M)*(2*N+1)+1):((m+M+1)*(2*N+1)),((j+M)*(2*N+1)+1):((j+M+1)*(2*N+1)))=X(:,(((m-j)+2*M)*(2*N+1)+1):(((m-j)+2*M+1)*(2*N+1)));
    end
end   
function Output=FC2DCh(m,l1,l3,l5,l2,l4,l6,d1,d2,epsilona,epsilonb,N) % Toeplitz matrix for 1D periodic structure in the x1 direction or in the x2 direction
q=sqrt(-1);
Epsi=zeros(4*N+1,1);
for n=-2*N:2*N
    if (m)==0 
        if (n)==0
            CF1=epsilonb;
            CF2=(epsilona-epsilonb)*(l3-l1)*(l4-l2)/d1/d2;
            CF3=(epsilona-epsilonb)*(l5-l3)*(l6-l4)/d1/d2;
            CF=CF1+CF2+CF3;
            Epsi(n+2*N+1)=CF;
        else
            CF3=(epsilona-epsilonb)*(exp(-q*2*pi*(n)*l6/d2)-exp(-q*2*pi*(n)*l4/d2))*(l5-l3)/(-2*q*pi*(n))/d1;  % Part # 3
            CF2=(epsilona-epsilonb)*(exp(-q*2*pi*(n)*l4/d2)-exp(-q*2*pi*(n)*l2/d2))*(l3-l1)/(-2*q*pi*(n))/d1;  % Part # 2
            CF1=0;   % Part # 1
            CF=(CF1+CF2+CF3);
            Epsi(n+2*N+1)=CF;
        end
    else
        if (n)==0
            CF3=(epsilona-epsilonb)*(exp(-q*2*pi*(m)*l5/d1)-exp(-q*2*pi*(m)*l3/d1))*(l6-l4)/(-2*q*pi*(m))/d2;  % Part # 3
            CF2=(epsilona-epsilonb)*(exp(-q*2*pi*(m)*l3/d1)-exp(-q*2*pi*(m)*l1/d1))*(l4-l2)/(-2*q*pi*(m))/d2;  % Part # 2
            CF1=0;   % Part # 1
            CF=(CF1+CF2+CF3);
            Epsi(n+2*N+1)=CF;
        else
            CF3=(epsilona-epsilonb)*(exp(-q*2*pi*(m)*l5/d1)-exp(-q*2*pi*(m)*l3/d1))*(exp(-q*2*pi*(n)*l6/d2)-exp(-q*2*pi*(n)*l4/d2))/(-4*pi*pi*(m)*(n));  % Part # 3
            CF2=(epsilona-epsilonb)*(exp(-q*2*pi*(m)*l3/d1)-exp(-q*2*pi*(m)*l1/d1))*(exp(-q*2*pi*(n)*l4/d2)-exp(-q*2*pi*(n)*l2/d2))/(-4*pi*pi*(m)*(n));  % Part # 2
            CF1=0;  % Part # 1
            CF=(CF1+CF2+CF3);
            Epsi(n+2*N+1)=CF;
        end
    end
end
Output=toeplitz(Epsi(2*N+1:4*N+1),Epsi(2*N+1:-1:1));